Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 4226)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4226 2019-09-10 17:03:24Z suehring
 ! Changes in interface for the offline nesting
 ! 
@@ -224,7 +227,4 @@
         ONLY:  cpu_log, log_point, log_point_s
 
-    USE date_and_time_mod,                                                                         &
-        ONLY:  calc_date_and_time, hour_call_emis, hour_of_year
-
     USE diagnostic_output_quantities_mod,                                                          &
         ONLY:  doq_calculate,                                                                      &
@@ -272,4 +272,7 @@
         ONLY:  prho_reference
 
+    USE palm_date_time_mod,                                                                        &
+        ONLY:  get_date_time
+
     USE particle_attributes,                                                                       &
         ONLY:  particle_advection, particle_advection_start, use_sgs_for_particles, wang_kernel
@@ -367,12 +370,14 @@
     CHARACTER (LEN=9) ::  time_to_string   !<
 
-    INTEGER(iwp) ::  ib        !< index for aerosol size bins
-    INTEGER(iwp) ::  ic        !< index for aerosol mass bins
-    INTEGER(iwp) ::  icc       !< additional index for aerosol mass bins
-    INTEGER(iwp) ::  ig        !< index for salsa gases
-    INTEGER(iwp) ::  lsp
-    INTEGER(iwp) ::  lsp_usr   !<
-    INTEGER(iwp) ::  mid       !< masked output running index
-    INTEGER(iwp) ::  n         !< loop counter for chemistry species
+    INTEGER(iwp) ::  hour            !< hour of current time
+    INTEGER(iwp) ::  hour_call_emis  !< last hour where emission was called
+    INTEGER(iwp) ::  ib              !< index for aerosol size bins
+    INTEGER(iwp) ::  ic              !< index for aerosol mass bins
+    INTEGER(iwp) ::  icc             !< additional index for aerosol mass bins
+    INTEGER(iwp) ::  ig              !< index for salsa gases
+    INTEGER(iwp) ::  lsp             !<
+    INTEGER(iwp) ::  lsp_usr         !<
+    INTEGER(iwp) ::  mid             !< masked output running index
+    INTEGER(iwp) ::  n               !< loop counter for chemistry species
 
     REAL(wp) ::  dt_3d_old  !< temporary storage of timestep to be used for
@@ -1192,11 +1197,12 @@
        IF ( air_chemistry  .AND.  emissions_anthropogenic )  THEN
 !
-!--       Update the time --> kanani: revise location of this CALL
-          CALL calc_date_and_time
-!
 !--       Call emission routine only once an hour
-          IF ( hour_of_year  >  hour_call_emis )  THEN
+          !> @todo Move check of hour_call_emis into chem_emissions_setup
+          CALL get_date_time( time_since_reference_point, hour=hour )
+          IF ( hour_call_emis /= hour )  THEN
+          !> @question Which of these two if-statements is correct?
+          ! IF ( hour_of_year  >  hour_call_emis )  THEN
              CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
-             hour_call_emis = hour_of_year
+             hour_call_emis = hour
           ENDIF
        ENDIF
@@ -1236,6 +1242,4 @@
        time_since_reference_point = simulated_time - coupling_start_time
        simulated_time_chr         = time_to_string( time_since_reference_point )
-
-
 
 
Index: /palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4226)
+++ /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4223 2019-09-10 09:20:47Z gronemeier
 ! Corrected "Former revisions" section
 ! 
@@ -79,13 +82,10 @@
         ONLY:  cpu_log, log_point_s
 
-    USE date_and_time_mod,                                                     &
-        ONLY: day_of_year_init, time_utc_init
-
     USE indices,                                                               &
         ONLY:  nbgp, nzb, nzt, nysg, nyng, nxlg, nxrg
 
-
     USE land_surface_model_mod,                                                &
         ONLY:  lsm_energy_balance, lsm_soil_model, lsm_swap_timelevel
+
     USE pegrid
 
@@ -94,4 +94,7 @@
 
     USE kinds
+
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time, seconds_per_hour
 
     USE radiation_model_mod,                                                   &
@@ -132,9 +135,11 @@
 
     INTEGER(iwp) :: current_timestep_number_spinup = 0  !< number if timestep during spinup
+    INTEGER(iwp) :: day_of_year                         !< day of the year
   
     LOGICAL :: run_control_header_spinup = .FALSE.  !< flag parameter for steering whether the header information must be output
 
-    REAL(wp) ::  pt_spinup   !< temporary storage of temperature
-    REAL(wp) ::  dt_save     !< temporary storage for time step
+    REAL(wp) ::  pt_spinup      !< temporary storage of temperature
+    REAL(wp) ::  dt_save        !< temporary storage for time step
+    REAL(wp) ::  second_of_day  !< second of the day
                   
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_save  !< temporary storage of temperature
@@ -234,6 +239,10 @@
 !--       shifted by one hour to simulate a lag between air temperature and
 !--       incoming radiation
+          CALL get_date_time( simulated_time - spinup_time - seconds_per_hour, &
+                              day_of_year=day_of_year,                         &
+                              second_of_day=second_of_day                      )
+
           pt_spinup = spinup_pt_mean + spinup_pt_amplitude                     &
-             * solar_angle (time_utc_init + time_since_reference_point - 3600.0)
+                                     * solar_angle(day_of_year, second_of_day)
 
 !
@@ -546,5 +555,7 @@
 !-- Returns the cosine of the solar zenith angle at a given time. This routine
 !-- is similar to that for calculation zenith (see radiation_model_mod.f90)
-    FUNCTION solar_angle( local_time ) 
+    !> @todo Load function calc_zenith of radiation model instead of
+    !>       rewrite the function here.
+    FUNCTION solar_angle( day_of_year, second_of_day ) 
 
        USE basic_constants_and_equations_mod,                                  &
@@ -559,23 +570,14 @@
 
 
-       REAL(wp) ::  solar_angle     !< cosine of the solar zenith angle
-
-       REAL(wp) ::  day             !< day of the year
-       REAL(wp) ::  declination     !< solar declination angle
-       REAL(wp) ::  hour_angle      !< solar hour angle
-       REAL(wp) ::  time_utc        !< current time in UTC
-       REAL(wp), INTENT(IN) :: local_time
-!
-!--    Calculate current day and time based on the initial values and simulation
-!--    time
-
-       day = day_of_year_init + INT(FLOOR( local_time / 86400.0_wp ), KIND=iwp)
-       time_utc = MOD(local_time, 86400.0_wp)
-
-
+       INTEGER(iwp), INTENT(IN) ::  day_of_year  !< day of the year
+
+       REAL(wp)             ::  declination      !< solar declination angle
+       REAL(wp)             ::  hour_angle       !< solar hour angle
+       REAL(wp), INTENT(IN) ::  second_of_day    !< current time of the day in UTC
+       REAL(wp)             ::  solar_angle      !< cosine of the solar zenith angle
 !
 !--    Calculate solar declination and hour angle   
-       declination = ASIN( decl_1 * SIN(decl_2 * REAL(day, KIND=wp) - decl_3) )
-       hour_angle  = 2.0_wp * pi * (time_utc / 86400.0_wp) + lon - pi
+       declination = ASIN( decl_1 * SIN(decl_2 * REAL(day_of_year, KIND=wp) - decl_3) )
+       hour_angle  = 2.0_wp * pi * (second_of_day / 86400.0_wp) + lon - pi
 
 !
@@ -584,5 +586,4 @@
                      * COS(hour_angle)
 
-
     END FUNCTION solar_angle
 
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4227)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod
+! 
+! 4214 2019-09-02 15:57:02Z suehring
 ! Bugfix, missing initialization and clearing of soil-moisture tendency 
 ! (J.Resler)
@@ -222,7 +225,4 @@
         ONLY:  cpu_log, log_point, log_point_s
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  time_utc_init
-
     USE grid_variables,                                                        &
         ONLY:  dx, dy, ddx, ddy, ddx2, ddy2
@@ -236,4 +236,7 @@
     USE kinds
               
+    USE palm_date_time_mod,                                                    &
+        ONLY:  get_date_time, seconds_per_hour
+
     USE pegrid
         
@@ -8305,6 +8308,5 @@
 !--        calculation of actual profile coefficient
 !--        ??? check time_since_reference_point ???
-            dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
-            dhour = INT(dtime/3600.0_wp)
+            CALL get_date_time( time_since_reference_point, hour=dhour, second_of_day=dtime )
 
 !--         TO_DO: activate, if testcase is available
@@ -8319,6 +8321,6 @@
 !--                    given to anthropogenic heat aheat*acoef (W*m-2)
 !--                    linear interpolation of coeficient
-                        acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(k,dhour) + &
-                                (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(k,dhour+1)
+                        acoef = (REAL(dhour+1,wp)-dtime/seconds_per_hour)*aheatprof(k,dhour) + &
+                                (dtime/seconds_per_hour-REAL(dhour,wp))*aheatprof(k,dhour+1)
                         IF ( aheat(k,j,i) > 0.0_wp )  THEN
 !
Index: /palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4226)
+++ /palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4227)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! implement new palm_date_time_mod and increased binary version
+! 
+! 4146 2019-08-07 07:47:36Z gronemeier
 ! Corrected "Former revisions" section
 ! 
@@ -67,7 +70,4 @@
     USE control_parameters
 
-    USE date_and_time_mod,                                                     &
-        ONLY:  day_of_year_init, time_utc_init
-
     USE grid_variables,                                                        &
         ONLY:  dx, dy
@@ -147,5 +147,5 @@
 
 
-       binary_version_global = '4.8'
+       binary_version_global = '4.9'
 
        CALL wrd_write_string( 'binary_version_global' )
@@ -299,6 +299,6 @@
        WRITE ( 14 )  damp_level_1d
 
-       CALL wrd_write_string( 'day_of_year_init' ) 
-       WRITE ( 14 )  day_of_year_init
+       CALL wrd_write_string( 'origin_date_time' ) 
+       WRITE ( 14 )  origin_date_time
 
        CALL wrd_write_string( 'dissipation_1d' ) 
@@ -679,7 +679,4 @@
        WRITE ( 14 )  time_since_reference_point
 
-       CALL wrd_write_string( 'time_utc_init' ) 
-       WRITE ( 14 )  time_utc_init
-
        CALL wrd_write_string( 'time_virtual_measurement' ) 
        WRITE ( 14 )  time_virtual_measurement
Index: /palm/trunk/TESTS/cases/rans_tkee/INPUT/rans_tkee_p3d
===================================================================
--- /palm/trunk/TESTS/cases/rans_tkee/INPUT/rans_tkee_p3d	(revision 4226)
+++ /palm/trunk/TESTS/cases/rans_tkee/INPUT/rans_tkee_p3d	(revision 4227)
@@ -23,5 +23,5 @@
          topography = 'read_from_file',
 
-         time_utc_init    = 0.0,
+         origin_date_time = '2000-01-01 00:00:00 +00',
 
          turbulence_closure = 'TKE-e',
Index: /palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d
===================================================================
--- /palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d	(revision 4226)
+++ /palm/trunk/TESTS/cases/urban_environment/INPUT/urban_environment_p3d	(revision 4227)
@@ -37,6 +37,5 @@
     vg_surface           = 0.0,
 
-    day_of_year_init     = 65,             ! march 06, to avoid extreme temperatures
-    time_utc_init        = 36000.0,        ! (0.0 s = 00 UTC midnight),
+    origin_date_time     = '2019-03-06 10:00:00 +00'
 
 !
Index: /palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr
===================================================================
--- /palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4226)
+++ /palm/trunk/TESTS/cases/urban_environment_restart/INPUT/urban_environment_restart_p3dr	(revision 4227)
@@ -36,6 +36,5 @@
     vg_surface           = 0.0,
 
-    day_of_year_init     = 65,             ! march 06, to avoid extreme temperatures
-    time_utc_init        = 36000.0,        ! (0.0 s = 00 UTC midnight),
+    origin_date_time     = '2019-03-06 10:00:00 +00'
 
 !
Index: /palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d
===================================================================
--- /palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4226)
+++ /palm/trunk/TESTS/cases/urban_environment_salsa/INPUT/urban_environment_salsa_p3d	(revision 4227)
@@ -37,6 +37,5 @@
     vg_surface           = 0.0,
 
-    day_of_year_init     = 65,             ! march 06, to avoid extreme temperatures
-    time_utc_init        = 36000.0,        ! (0.0 s = 00 UTC midnight),
+    origin_date_time     = '2019-03-06 10:00:00 +00'
 
 !
